## libssh 0.3.4

=== CMakeLists.txt ===
project(libssh C)

# Required cmake version
cmake_minimum_required(VERSION 2.6.0)

# global needed variables
set(APPLICATION_NAME ${PROJECT_NAME})

set(APPLICATION_VERSION "0.3.4")

set(APPLICATION_VERSION_MAJOR "0")
set(APPLICATION_VERSION_MINOR "3")
set(APPLICATION_VERSION_PATCH "4")

set(LIBRARY_VERSION "3.4.0")
set(LIBRARY_SOVERSION "3")

# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
set(CMAKE_MODULE_PATH
  ${CMAKE_SOURCE_DIR}/cmake/Modules
)

# add definitions
include(DefineCMakeDefaults)
include(DefineCompilerFlags)
include(DefineInstallationPaths)
include(DefineOptions.cmake)
include(CPackConfig.cmake)

# disallow in-source build
include(MacroEnsureOutOfSourceBuild)
macro_ensure_out_of_source_build("${PROJECT_NAME} requires an out of source build. Please create a separate build directory and run 'cmake /path/to/${PROJECT_NAME} [options]' there.")

# add macros
include(MacroAddPlugin)
include(MacroCopyFile)

# search for libraries
find_package(ZLIB REQUIRED)

find_package(OpenSSL)

if (NOT CRYPTO_FOUND)
  find_package(GCrypt)
  if (NOT GCRYPT_FOUND)
    message(FATAL_ERROR "Could not find OpenSSL or GCrypt")
  endif (NOT GCRYPT_FOUND)
endif (NOT CRYPTO_FOUND)

# config.h checks
include(ConfigureChecks.cmake)
configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# check subdirectories
add_subdirectory(doc)
add_subdirectory(include)
add_subdirectory(libssh)

# build samples
include_directories(${CMAKE_SOURCE_DIR}/include)

if (UNIX AND NOT WIN32)
  if (WITH_SFTP AND WITH_SERVER)
    add_executable(samplessh sample.c)
    add_executable(samplesshd samplesshd.c)

    target_link_libraries(samplessh ${LIBSSH_SHARED_LIBRARY})
    target_link_libraries(samplesshd ${LIBSSH_SHARED_LIBRARY})
  endif (WITH_SFTP AND WITH_SERVER)
endif (UNIX AND NOT WIN32)

=== libssh/CMakeLists.txt ===
project(libssh-library C)

set(LIBSSH_PUBLIC_INCLUDE_DIRS
  ${CMAKE_SOURCE_DIR}/include
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}
  CACHE INTERNAL "libssh public include directories"
)

set(LIBSSH_PRIVATE_INCLUDE_DIRS
  ${CMAKE_BINARY_DIR}
  ${ZLIB_INCLUDE_DIRS}
)

set(LIBSSH_SHARED_LIBRARY
  ssh_shared
  CACHE INTERNAL "libssh shared library"
)

if (WITH_STATIC_LIB)
  set(LIBSSH_STATIC_LIBRARY
    ssh_static
    CACHE INTERNAL "libssh static library"
  )
endif (WITH_STATIC_LIB)

set(LIBSSH_LINK_LIBRARIES
  ${ZLIB_LIBRARIES}
)

if (WIN32)
  set(LIBSSH_LINK_LIBRARIES
    ${LIBSSH_LINK_LIBRARIES}
    ws2_32
  )
endif (WIN32)

if (CRYPTO_LIBRARY)
  set(LIBSSH_PRIVATE_INCLUDE_DIRS
    ${LIBSSH_PRIVATE_INCLUDE_DIRS}
    ${OPENSSL_INCLUDE_DIRS}
  )

  set(LIBSSH_LINK_LIBRARIES
    ${LIBSSH_LINK_LIBRARIES}
    ${CRYPTO_LIBRARY}
  )
endif (CRYPTO_LIBRARY)

if (GCRYPT_LIBRARY)
  set(LIBSSH_PRIVATE_INCLUDE_DIRS
    ${LIBSSH_PRIVATE_INCLUDE_DIRS}
    ${GCRYPT_INCLUDE_DIRS}
  )

  set(LIBSSH_LINK_LIBRARIES
    ${LIBSSH_LINK_LIBRARIES}
    ${GCRYPT_LIBRARY}
  )
endif (GCRYPT_LIBRARY)


set(libssh_SRCS
  agent.c
  auth.c
  base64.c
  buffer.c
  channels.c
  client.c
  connect.c
  crc32.c
  crypt.c
  dh.c
  error.c
  gcrypt_missing.c
  gzip.c
  init.c
  kex.c
  keyfiles.c
  keys.c
  log.c
  match.c
  messages.c
  misc.c
  options.c
  packet.c
  poll.c
  session.c
  socket.c
  string.c
  wrapper.c
  libssh.map
)

if (WITH_SFTP)
  set(libssh_SRCS
    ${libssh_SRCS}
    sftp.c
  )

  if (WITH_SERVER)
    set(libssh_SRCS
      ${libssh_SRCS}
      sftpserver.c
    )
  endif (WITH_SERVER)
endif (WITH_SFTP)

if (WITH_SSH1)
  set(libssh_SRCS
    ${libssh_SRCS}
    auth1.c
    channels1.c
  )
endif (WITH_SSH1)

if (WITH_SERVER)
  set(libssh_SRCS
    ${libssh_SRCS}
    server.c
  )
endif (WITH_SERVER)

include_directories(
  ${LIBSSH_PUBLIC_INCLUDE_DIRS}
  ${LIBSSH_PRIVATE_INCLUDE_DIRS}
)

add_library(${LIBSSH_SHARED_LIBRARY} SHARED ${libssh_SRCS})

target_link_libraries(${LIBSSH_SHARED_LIBRARY} ${LIBSSH_LINK_LIBRARIES})

set_target_properties(
  ${LIBSSH_SHARED_LIBRARY}
    PROPERTIES
      VERSION
        ${LIBRARY_VERSION}
      SOVERSION
        ${LIBRARY_SOVERSION}
      OUTPUT_NAME
        ssh
)

install(
  TARGETS
    ${LIBSSH_SHARED_LIBRARY}
  DESTINATION
    ${LIB_INSTALL_DIR}
  COMPONENT
    libraries
)

if (WITH_STATIC_LIB)
  add_library(${LIBSSH_STATIC_LIBRARY} STATIC ${libssh_SRCS})

  target_link_libraries(${LIBSSH_STATIC_LIBRARY} ${LIBSSH_LINK_LIBRARIES})

  set_target_properties(
    ${LIBSSH_STATIC_LIBRARY}
      PROPERTIES
        VERSION
          ${LIBRARY_VERSION}
        SOVERSION
          ${LIBRARY_SOVERSION}
        OUTPUT_NAME
          ssh
  )

  install(
    TARGETS
      ${LIBSSH_STATIC_LIBRARY}
    DESTINATION
      ${LIB_INSTALL_DIR}
    COMPONENT
      libraries
  )
endif (WITH_STATIC_LIB)

=== tests/Makefile ===
all: test_tunnel test_exec
CFLAGS=-I../include/ -g -Wall
LDFLAGS=-lssh -L../build/libssh/

test_tunnel: test_tunnel.o authentication.o connection.o
	gcc -o $@ $^ $(LDFLAGS)

test_exec: test_exec.o authentication.o connection.o
	gcc -o $@ $^ $(LDFLAGS)

clean:
	rm -f *.o test_tunnel

=== include/libssh/CMakeLists.txt ===
project(libssh-headers C)

set(libssh_HDRS
  libssh.h
  crypto.h
  ssh2.h
)

if (WITH_SFTP)
  set(libssh_HDRS
    ${libssh_HDRS}
    sftp.h
  )
endif (WITH_SFTP)

if (WITH_SSH1)
  set(libssh_HDRS
    ${libssh_HDRS}
    ssh1.h
  )
endif (WITH_SSH1)

if (WITH_SERVER)
  set(libssh_HDRS
    ${libssh_HDRS}
    server.h
  )
endif (WITH_SERVER)

install(
  FILES
    ${libssh_HDRS}
  DESTINATION
    ${INCLUDE_INSTALL_DIR}/${APPLICATION_NAME}
  COMPONENT
    headers
)

## libssh 0.4.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,14 +6,14 @@
 # global needed variables
 set(APPLICATION_NAME ${PROJECT_NAME})
 
-set(APPLICATION_VERSION "0.3.4")
+set(APPLICATION_VERSION_MAJOR "0")
+set(APPLICATION_VERSION_MINOR "4")
+set(APPLICATION_VERSION_PATCH "2")
 
-set(APPLICATION_VERSION_MAJOR "0")
-set(APPLICATION_VERSION_MINOR "3")
-set(APPLICATION_VERSION_PATCH "4")
+set(APPLICATION_VERSION "${APPLICATION_VERSION_MAJOR}${APPLICATION_VERSION_MINOR}${APPLICATION_VERSION_PATCH}")
 
-set(LIBRARY_VERSION "3.4.0")
-set(LIBRARY_SOVERSION "3")
+set(LIBRARY_VERSION "4.0.2")
+set(LIBRARY_SOVERSION "4")
 
 # where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
 set(CMAKE_MODULE_PATH
@@ -38,14 +38,20 @@
 # search for libraries
 find_package(ZLIB REQUIRED)
 
-find_package(OpenSSL)
-
-if (NOT CRYPTO_FOUND)
-  find_package(GCrypt)
+if (WITH_GCRYPT)
+  find_package(GCrypt REQUIRED)
   if (NOT GCRYPT_FOUND)
-    message(FATAL_ERROR "Could not find OpenSSL or GCrypt")
+    message(FATAL_ERROR "Could not find GCrypt")
   endif (NOT GCRYPT_FOUND)
-endif (NOT CRYPTO_FOUND)
+else (WITH_GCRYPT)
+  find_package(OpenSSL)
+  if (NOT CRYPTO_FOUND)
+    find_package(GCrypt)
+    if (NOT GCRYPT_FOUND)
+      message(FATAL_ERROR "Could not find OpenSSL or GCrypt")
+    endif (NOT GCRYPT_FOUND)
+  endif (NOT CRYPTO_FOUND)
+endif(WITH_GCRYPT)
 
 # config.h checks
 include(ConfigureChecks.cmake)
@@ -60,11 +66,6 @@
 include_directories(${CMAKE_SOURCE_DIR}/include)
 
 if (UNIX AND NOT WIN32)
-  if (WITH_SFTP AND WITH_SERVER)
-    add_executable(samplessh sample.c)
-    add_executable(samplesshd samplesshd.c)
+  add_subdirectory(examples)
 
-    target_link_libraries(samplessh ${LIBSSH_SHARED_LIBRARY})
-    target_link_libraries(samplesshd ${LIBSSH_SHARED_LIBRARY})
-  endif (WITH_SFTP AND WITH_SERVER)
 endif (UNIX AND NOT WIN32)

=== libssh/CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,7 @@
 endif (WITH_STATIC_LIB)
 
 set(LIBSSH_LINK_LIBRARIES
+  ${LIBSSH_REQUIRED_LIBRARIES}
   ${ZLIB_LIBRARIES}
 )
 
@@ -34,6 +35,13 @@
     ws2_32
   )
 endif (WIN32)
+
+if (HAVE_LIBSOCKET)
+  set(LIBSSH_LINK_LIBRARIES
+    ${LIBSSH_LINK_LIBRARIES}
+    socket
+  )
+endif (HAVE_LIBSOCKET)
 
 if (CRYPTO_LIBRARY)
   set(LIBSSH_PRIVATE_INCLUDE_DIRS
@@ -58,15 +66,16 @@
     ${GCRYPT_LIBRARY}
   )
 endif (GCRYPT_LIBRARY)
-
 
 set(libssh_SRCS
   agent.c
   auth.c
   base64.c
   buffer.c
+  callbacks.c
   channels.c
   client.c
+  config.c
   connect.c
   crc32.c
   crypt.c
@@ -86,11 +95,19 @@
   packet.c
   poll.c
   session.c
+  scp.c
   socket.c
   string.c
   wrapper.c
-  libssh.map
-)
+)
+
+if (WITH_PCAP)
+  set(libssh_SRCS
+    ${libssh_SRCS}
+    pcap.c
+  )
+
+endif (WITH_PCAP)
 
 if (WITH_SFTP)
   set(libssh_SRCS
@@ -139,21 +156,26 @@
         ${LIBRARY_SOVERSION}
       OUTPUT_NAME
         ssh
-)
+      DEFINE_SYMBOL
+        LIBSSH_EXPORTS
+)
+
+if (WITH_VISIBILITY_HIDDEN)
+  set_target_properties(${LIBSSH_SHARED_LIBRARY} PROPERTIES COMPILE_FLAGS "-fvisibility=hidden")
+endif (WITH_VISIBILITY_HIDDEN)
+
 
 install(
   TARGETS
     ${LIBSSH_SHARED_LIBRARY}
-  DESTINATION
-    ${LIB_INSTALL_DIR}
-  COMPONENT
-    libraries
+  RUNTIME DESTINATION ${BIN_INSTALL_DIR}
+  LIBRARY DESTINATION ${LIB_INSTALL_DIR}
+  ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
+  COMPONENT libraries
 )
 
 if (WITH_STATIC_LIB)
   add_library(${LIBSSH_STATIC_LIBRARY} STATIC ${libssh_SRCS})
-
-  target_link_libraries(${LIBSSH_STATIC_LIBRARY} ${LIBSSH_LINK_LIBRARIES})
 
   set_target_properties(
     ${LIBSSH_STATIC_LIBRARY}
@@ -162,8 +184,8 @@
           ${LIBRARY_VERSION}
         SOVERSION
           ${LIBRARY_SOVERSION}
-        OUTPUT_NAME
-          ssh
+        COMPILE_FLAGS
+          "-DLIBSSH_STATIC"
   )
 
   install(

=== debian/changelog ===
libssh (0.4.2-1ubuntu1) lucid; urgency=low

  * Merge with Debian testing, remaining change:
    - Include conflicts/replaces on previous package versions with old sonames
      (LP: #514110)

 -- Jonathan Thomas <echidnaman@kubuntu.org>  Mon, 12 Apr 2010 19:07:38 -0400

libssh (0.4.2-1) unstable; urgency=low

  * New upstream release
    - 0001-Fix-symbols-visibility.patch: Only export needed symbols
    - debian/libssh-4.symbols: Update symbols file

 -- Laurent Bigonville <bigon@debian.org>  Thu, 25 Mar 2010 13:38:35 +0100

libssh (0.4.1-1) unstable; urgency=low

  * New upstream release
  * debian/control: Bump Standards-Version (no further changes)
  * Use new source package format '3.0 (quilt)'

 -- Laurent Bigonville <bigon@debian.org>  Sat, 13 Feb 2010 20:18:18 +0100

libssh (0.4.0-1ubuntu1) lucid; urgency=low

  * Merge with Debian:
    - Include conflict/replaces on previous package versions with old sonames

 -- Jonathan Thomas <echidnaman@kubuntu.org>  Sun, 13 Dec 2009 20:31:49 -0500

libssh (0.4.0-1) unstable; urgency=low

  * New upstream release.
    - Bump soname
    - Adjust .symbols file
  * Readd static library in -dev package
  * Let dh_lintian install override file
  * debian/README.Debian: Update file
  * debian/rules: Add list-missing rule

 -- Laurent Bigonville <bigon@debian.org>  Sat, 12 Dec 2009 14:29:12 +0100

libssh (0.3.92-0ubuntu1) lucid; urgency=low

  * New upstream prerelease:
    - Bump library .so number in binary packages
    - Update .symbols file

 -- Jonathan Thomas <echidnaman@kubuntu.org>  Wed, 02 Dec 2009 09:19:22 -0500

libssh (0.3.4-3) unstable; urgency=low

  * Add correct Conflicts/Replaces for -dev and -doc packages
    (Closes: #550996)

 -- Laurent Bigonville <bigon@debian.org>  Thu, 15 Oct 2009 09:59:57 +0200

libssh (0.3.4-2ubuntu1) karmic; urgency=low

  * Merge with Debian
  * Include conflict/replaces on previous package versions with old sonames

 -- Jonathan Riddell <jriddell@ubuntu.com>  Mon, 12 Oct 2009 16:42:36 +0100

libssh (0.3.4-2) unstable; urgency=low

  * debian/watch: Update the URL
  * debian/copyright: Add missing licence for some cmake/Modules files

 -- Laurent Bigonville <bigon@debian.org>  Mon, 12 Oct 2009 09:37:03 +0200

libssh (0.3.4-1) unstable; urgency=low

  * New upstream release (Closes: #467284).
    - Adjust build-deps and use cmake
    - Bump soname and adjust .symbols file
  * debian/control:
    - Use my debian.org address in Uploaders and takeover the package
      with Jean-Philippe permission
    - Use now official Vcs-* field
    - Use new Homepage field instead of old pseudo-field
    - Bump Standards-Version to 3.8.3 (no further changes)
    - Use debug section for -dbg package
    - Add ${misc:Depends} to please lintian
    - Remove duplicate section to please lintian
  * debian/libssh-2-doc.doc-base: Fix doc-base-uses-applications-section
  * Bump debhelper version to 7
  * debian/libssh-dev.install: do not install .la file and static
    library anymore
  * debian/libssh-3.lintian-overrides: Update override
  * debian/copyright: Update copyright file
  * debian/libssh-3.symbols: Add initial symbols file

 -- Laurent Bigonville <bigon@debian.org>  Fri, 09 Oct 2009 21:21:16 +0200

libssh (0.3.4-0ubuntu2) karmic; urgency=low

  * Add missing build-dep on cmake

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 09 Oct 2009 17:30:05 +0100

libssh (0.3.4-0ubuntu1) karmic; urgency=low

  * New upstream release, closes LP: #447364

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 09 Oct 2009 16:11:53 +0100

libssh (0.2+svn20070321-4) unstable; urgency=low

  * debian/control:
    - Add XS-Vcs-Svn and XS-Vcs-Browser fields.
    - Change to ${binary:Version} for versionized dependencies.
  * Add debian/README.Debian to disambiguate the package name 

 -- Laurent Bigonville <bigon@bigon.be>  Fri, 27 Jul 2007 15:00:06 +0200

libssh (0.2+svn20070321-3) unstable; urgency=low

  * Fix wrong versionized Replaces for -doc package

 -- Laurent Bigonville <bigon@bigon.be>  Thu,  5 Apr 2007 17:58:27 +0200

libssh (0.2+svn20070321-2) unstable; urgency=low

  * Split devel package into devel and documentation packages 

 -- Laurent Bigonville <bigon@bigon.be>  Mon, 26 Mar 2007 15:29:51 +0200

libssh (0.2+svn20070321-1) unstable; urgency=low

  * New svn snapshot:
    - Fix broken include in include/libssh/server.h (Closes: #410020)
    - Fix nasty bug in server side code

 -- Laurent Bigonville <bigon@bigon.be>  Mon, 26 Mar 2007 15:06:40 +0200

libssh (0.2-1) unstable; urgency=low

  * New upstream release. 

 -- Laurent Bigonville <bigon@bigon.be>  Fri, 29 Dec 2006 07:40:20 +0100

libssh (0.2~rc-1) unstable; urgency=low

  * Initial release (Closes: #316872)

 -- Jean-Philippe Garcia Ballester <giga@le-pec.org>  Wed, 20 Dec 2006 23:56:50 +0100

=== debian/control ===
Source: libssh
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Laurent Bigonville <bigon@debian.org>
Build-Depends: cdbs, debhelper (>= 7), cmake (>= 2.6), libssl-dev, libz-dev, doxygen
Standards-Version: 3.8.4
Vcs-Git: git://git.debian.org/git/collab-maint/libssh.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/libssh.git
Homepage: http://www.libssh.org/

Package: libssh-4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libssh-2, libssh-3
Conflicts: libssh-2, libssh-3
Description: A tiny C SSH library
 The ssh library was designed to be used by programmers needing a working SSH
 implementation by the mean of a library. The complete control of the client
 is made by the programmer. With libssh, you can remotely execute programs,
 transfer files, use a secure and transparent tunnel for your remote programs.
 With its SFTP implementation, you can play with remote files easily.

Package: libssh-dev
Section: libdevel
Architecture: any
Depends: libssh-4 (= ${binary:Version}), ${misc:Depends}, libssl-dev, zlib1g-dev
Suggests: libssh-doc
Conflicts: libssh-2-dev, libssh-3-dev
Replaces: libssh-3-dev
Description: A tiny C SSH library. Development files
 The ssh library was designed to be used by programmers needing a working SSH
 implementation by the mean of a library. The complete control of the client
 is made by the programmer. With libssh, you can remotely execute programs,
 transfer files, use a secure and transparent tunnel for your remote programs.
 With its SFTP implementation, you can play with remote files easily.
 .
 This package contains development files.

Package: libssh-dbg
Priority: extra
Section: debug
Architecture: any
Depends: libssh-4 (= ${binary:Version}), ${misc:Depends}
Conflicts: libssh-2-dbg, libssh-3-dbg
Replaces: libssh-3-dbg
Description: A tiny C SSH library. Debug symbols
 The ssh library was designed to be used by programmers needing a working SSH
 implementation by the mean of a library. The complete control of the client
 is made by the programmer. With libssh, you can remotely execute programs,
 transfer files, use a secure and transparent tunnel for your remote programs.
 With its SFTP implementation, you can play with remote files easily.
 .
 This package contains debug symbols.

Package: libssh-doc
Section: doc
Architecture: all
Suggests: doc-base
Depends: ${misc:Depends}
Replaces: libssh-2-dev (<< 0.2+svn20070321-2), libssh-2-doc, libssh-3-doc
Conflicts: libssh-2-doc, libssh-3-doc
Description: A tiny C SSH library. Documentation files
 The ssh library was designed to be used by programmers needing a working SSH
 implementation by the mean of a library. The complete control of the client
 is made by the programmer. With libssh, you can remotely execute programs,
 transfer files, use a secure and transparent tunnel for your remote programs.
 With its SFTP implementation, you can play with remote files easily.
 .
 This package contains documentation files.

## libssh 0.4.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,11 +8,18 @@
 
 set(APPLICATION_VERSION_MAJOR "0")
 set(APPLICATION_VERSION_MINOR "4")
-set(APPLICATION_VERSION_PATCH "2")
+set(APPLICATION_VERSION_PATCH "5")
 
-set(APPLICATION_VERSION "${APPLICATION_VERSION_MAJOR}${APPLICATION_VERSION_MINOR}${APPLICATION_VERSION_PATCH}")
+set(APPLICATION_VERSION "${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH}")
 
-set(LIBRARY_VERSION "4.0.2")
+# SOVERSION scheme: CURRENT.AGE.REVISION
+#   If there was an incompatible interface change:
+#     Increment CURRENT. Set AGE and REVISION to 0
+#   If there was a compatible interface change:
+#     Increment AGE. Set REVISION to 0
+#   If the source code was changed, but there were no interface changes:
+#     Increment REVISION.
+set(LIBRARY_VERSION "4.1.2")
 set(LIBRARY_SOVERSION "4")
 
 # where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
@@ -45,12 +52,12 @@
   endif (NOT GCRYPT_FOUND)
 else (WITH_GCRYPT)
   find_package(OpenSSL)
-  if (NOT CRYPTO_FOUND)
+  if (NOT OPENSSL_FOUND)
     find_package(GCrypt)
     if (NOT GCRYPT_FOUND)
       message(FATAL_ERROR "Could not find OpenSSL or GCrypt")
     endif (NOT GCRYPT_FOUND)
-  endif (NOT CRYPTO_FOUND)
+  endif (NOT OPENSSL_FOUND)
 endif(WITH_GCRYPT)
 
 # config.h checks
@@ -65,7 +72,7 @@
 # build samples
 include_directories(${CMAKE_SOURCE_DIR}/include)
 
-if (UNIX AND NOT WIN32)
+if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
   add_subdirectory(examples)
+endif (CMAKE_SYSTEM_NAME STREQUAL "Linux")
 
-endif (UNIX AND NOT WIN32)

=== examples/CMakeLists.txt ===
project(libssh-examples C)

set(examples_SRCS
  authentication.c
  knownhosts.c
  connect_ssh.c
)

include_directories(
  ${LIBSSH_PUBLIC_INCLUDE_DIRS}
  ${LIBSSH_PRIVATE_INCLUDE_DIRS}  
)

add_executable(libssh_scp libssh_scp.c ${examples_SRCS})
add_executable(scp_download scp_download.c ${examples_SRCS})
add_executable(samplessh sample.c ${examples_SRCS})
add_executable(exec exec.c ${examples_SRCS})

target_link_libraries(libssh_scp ${LIBSSH_SHARED_LIBRARY})
target_link_libraries(scp_download ${LIBSSH_SHARED_LIBRARY})
target_link_libraries(samplessh ${LIBSSH_SHARED_LIBRARY})
target_link_libraries(exec ${LIBSSH_SHARED_LIBRARY})

include_directories(
  ${LIBSSH_PUBLIC_INCLUDE_DIRS}
  ${CMAKE_BINARY_DIR}
)

if (WITH_SFTP)
  add_executable(samplesftp samplesftp.c ${examples_SRCS})
  target_link_libraries(samplesftp ${LIBSSH_SHARED_LIBRARY})
endif (WITH_SFTP)

if (WITH_SERVER)
  add_executable(samplesshd samplesshd.c)
  target_link_libraries(samplesshd ${LIBSSH_SHARED_LIBRARY})
endif (WITH_SERVER)

=== libssh/CMakeLists.txt ===
--- 
+++ 
@@ -43,7 +43,7 @@
   )
 endif (HAVE_LIBSOCKET)
 
-if (CRYPTO_LIBRARY)
+if (OPENSSL_LIBRARIES)
   set(LIBSSH_PRIVATE_INCLUDE_DIRS
     ${LIBSSH_PRIVATE_INCLUDE_DIRS}
     ${OPENSSL_INCLUDE_DIRS}
@@ -51,9 +51,9 @@
 
   set(LIBSSH_LINK_LIBRARIES
     ${LIBSSH_LINK_LIBRARIES}
-    ${CRYPTO_LIBRARY}
-  )
-endif (CRYPTO_LIBRARY)
+    ${OPENSSL_LIBRARIES}
+  )
+endif (OPENSSL_LIBRARIES)
 
 if (GCRYPT_LIBRARY)
   set(LIBSSH_PRIVATE_INCLUDE_DIRS

=== tests/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-all: test_tunnel test_exec
+all: test_tunnel test_exec test_pcap
 CFLAGS=-I../include/ -g -Wall
 LDFLAGS=-lssh -L../build/libssh/
 
@@ -8,5 +8,8 @@
 test_exec: test_exec.o authentication.o connection.o
 	gcc -o $@ $^ $(LDFLAGS)
 
+test_pcap: test_pcap.o
+	gcc -o $@ $^ $(LDFLAGS)
+
 clean:
 	rm -f *.o test_tunnel

=== include/libssh/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 project(libssh-headers C)
 
 set(libssh_HDRS
+  callbacks.h
   libssh.h
-  crypto.h
   ssh2.h
 )

=== debian/changelog ===
libssh (0.4.5-1) unstable; urgency=low

  * New upstream release
  * Bump Standards-Version to 3.9.0 (no further changes)
  * Move doxygen to Build-Depends-Indep

 -- Laurent Bigonville <bigon@debian.org>  Sun, 18 Jul 2010 22:48:10 +0200

libssh (0.4.4-1) unstable; urgency=low

  * New upstream release
    - Should fix ~/.ssh directory access (Closes: #582461)

 -- Laurent Bigonville <bigon@debian.org>  Mon, 31 May 2010 20:10:56 +0200

libssh (0.4.3-1) unstable; urgency=low

  * New upstream release
    - Drop 0001-Fix-symbols-visibility.patch, applied upstream
    - Update debian/libssh-4.symbols: Add new symbol

 -- Laurent Bigonville <bigon@debian.org>  Tue, 18 May 2010 21:06:33 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: libssh
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Laurent Bigonville <bigon@debian.org>
-Build-Depends: cdbs, debhelper (>= 7), cmake (>= 2.6), libssl-dev, libz-dev, doxygen
-Standards-Version: 3.8.4
+Maintainer: Laurent Bigonville <bigon@debian.org>
+Build-Depends: cdbs, debhelper (>= 7), cmake (>= 2.6), libssl-dev, libz-dev
+Build-Depends-Indep: doxygen
+Standards-Version: 3.9.0
 Vcs-Git: git://git.debian.org/git/collab-maint/libssh.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/libssh.git
 Homepage: http://www.libssh.org/
@@ -12,8 +12,6 @@
 Package: libssh-4
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Replaces: libssh-2, libssh-3
-Conflicts: libssh-2, libssh-3
 Description: A tiny C SSH library
  The ssh library was designed to be used by programmers needing a working SSH
  implementation by the mean of a library. The complete control of the client
@@ -26,8 +24,8 @@
 Architecture: any
 Depends: libssh-4 (= ${binary:Version}), ${misc:Depends}, libssl-dev, zlib1g-dev
 Suggests: libssh-doc
-Conflicts: libssh-2-dev, libssh-3-dev
-Replaces: libssh-3-dev
+Conflicts: libssh-2-dev
+Replaces: libssh-2-dev
 Description: A tiny C SSH library. Development files
  The ssh library was designed to be used by programmers needing a working SSH
  implementation by the mean of a library. The complete control of the client
@@ -42,8 +40,6 @@
 Section: debug
 Architecture: any
 Depends: libssh-4 (= ${binary:Version}), ${misc:Depends}
-Conflicts: libssh-2-dbg, libssh-3-dbg
-Replaces: libssh-3-dbg
 Description: A tiny C SSH library. Debug symbols
  The ssh library was designed to be used by programmers needing a working SSH
  implementation by the mean of a library. The complete control of the client
@@ -58,8 +54,8 @@
 Architecture: all
 Suggests: doc-base
 Depends: ${misc:Depends}
-Replaces: libssh-2-dev (<< 0.2+svn20070321-2), libssh-2-doc, libssh-3-doc
-Conflicts: libssh-2-doc, libssh-3-doc
+Conflicts: libssh-2-doc
+Replaces: libssh-2-doc
 Description: A tiny C SSH library. Documentation files
  The ssh library was designed to be used by programmers needing a working SSH
  implementation by the mean of a library. The complete control of the client

=== debian/rules ===
#!/usr/bin/make -f

DEB_AUTO_CLEANUP_RCS            := yes

DEB_CMAKE_EXTRA_FLAGS := -DWITH_STATIC_LIB=ON

include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/debhelper.mk
#include /usr/share/cdbs/1/rules/simple-patchsys.mk

DEB_DBG_PACKAGE_libssh-4 = libssh-dbg

# List any files which are not installed
include /usr/share/cdbs/1/rules/utils.mk
common-binary-post-install-arch:: list-missing

common-build-indep::
	cd obj-*/; make doc

=== debian/watch ===
version=3
http://www.libssh.org/files/libssh-(.*)\.tar.gz

## libssh 0.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,8 +7,8 @@
 set(APPLICATION_NAME ${PROJECT_NAME})
 
 set(APPLICATION_VERSION_MAJOR "0")
-set(APPLICATION_VERSION_MINOR "4")
-set(APPLICATION_VERSION_PATCH "5")
+set(APPLICATION_VERSION_MINOR "5")
+set(APPLICATION_VERSION_PATCH "2")
 
 set(APPLICATION_VERSION "${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}.${APPLICATION_VERSION_PATCH}")
 
@@ -19,7 +19,7 @@
 #     Increment AGE. Set REVISION to 0
 #   If the source code was changed, but there were no interface changes:
 #     Increment REVISION.
-set(LIBRARY_VERSION "4.1.2")
+set(LIBRARY_VERSION "4.2.2")
 set(LIBRARY_SOVERSION "4")
 
 # where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
@@ -29,6 +29,7 @@
 
 # add definitions
 include(DefineCMakeDefaults)
+include(DefinePlatformDefaults)
 include(DefineCompilerFlags)
 include(DefineInstallationPaths)
 include(DefineOptions.cmake)
@@ -43,7 +44,9 @@
 include(MacroCopyFile)
 
 # search for libraries
-find_package(ZLIB REQUIRED)
+if (WITH_LIBZ)
+    find_package(ZLIB REQUIRED)
+endif (WITH_LIBZ)
 
 if (WITH_GCRYPT)
   find_package(GCrypt REQUIRED)
@@ -60,6 +63,10 @@
   endif (NOT OPENSSL_FOUND)
 endif(WITH_GCRYPT)
 
+# Find out if we have threading available
+set(CMAKE_THREAD_PREFER_PTHREADS ON)
+find_package(Threads)
+
 # config.h checks
 include(ConfigureChecks.cmake)
 configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
@@ -67,12 +74,46 @@
 # check subdirectories
 add_subdirectory(doc)
 add_subdirectory(include)
-add_subdirectory(libssh)
+add_subdirectory(src)
 
-# build samples
-include_directories(${CMAKE_SOURCE_DIR}/include)
+# pkg-config file
+configure_file(libssh.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/libssh.pc)
+configure_file(libssh_threads.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/libssh_threads.pc)
+install(
+  FILES
+    ${CMAKE_CURRENT_BINARY_DIR}/libssh.pc
+    ${CMAKE_CURRENT_BINARY_DIR}/libssh_threads.pc
+  DESTINATION
+    ${LIB_INSTALL_DIR}/pkgconfig
+  COMPONENT
+    pkgconfig
+)
 
-if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
-  add_subdirectory(examples)
-endif (CMAKE_SYSTEM_NAME STREQUAL "Linux")
+add_subdirectory(examples)
 
+if (WITH_TESTING)
+  find_package(CMockery REQUIRED)
+  include(AddCMockeryTest)
+  add_subdirectory(tests)
+endif (WITH_TESTING)
+
+
+message(STATUS "********************************************")
+message(STATUS "********** ${PROJECT_NAME} build options : **********")
+
+message(STATUS "zlib support: ${WITH_LIBZ}")
+message(STATUS "libgcrypt support: ${WITH_GCRYPT}")
+message(STATUS "SSH-1 support: ${WITH_SSH1}")
+message(STATUS "SFTP support: ${WITH_SFTP}")
+message(STATUS "Server support : ${WITH_SERVER}")
+message(STATUS "Pcap debugging support : ${WITH_PCAP}")
+message(STATUS "Unit testing: ${WITH_TESTING}")
+message(STATUS "Client code Unit testing: ${WITH_CLIENT_TESTING}")
+if (WITH_INTERNAL_DOC)
+    message(STATUS "Internal documentation generation")
+else (WITH_INTERNAL_DOC)
+    message(STATUS "Public API documentation generation")
+endif (WITH_INTERNAL_DOC)
+message(STATUS "Benchmarks: ${WITH_BENCHMARKS}")
+message(STATUS "********************************************")
+

=== debian/changelog ===
libssh (0.5.2-1ubuntu0.12.04.2) precise-security; urgency=low

  * SECURITY UPDATE: denial of service via NULL dereference
    - debian/patches/CVE-2013-0176.patch: properly handle client that
      doesn't send a matching key in src/server.c.
    - CVE-2013-0176

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 25 Jan 2013 13:43:46 -0500

libssh (0.5.2-1ubuntu0.12.04.1) precise-security; urgency=low

  * SECURITY UPDATE: denial of service and possible code execution via
    multiple double free flaws
    - debian/patches/CVE-2012-4559.patch: properly do frees in src/agent.c,
      src/channels.c, src/sftp.c.
    - CVE-2012-4559
  * SECURITY UPDATE: denial of service and possible code execution via
    multiple buffer overflows
    - debian/patches/CVE-2012-4560.patch: properly calculate sizes in
      src/misc.c.
    - CVE-2012-4560
  * SECURITY UPDATE: denial of service and possible code execution via
    multiple invalid free flaws
    - debian/patches/CVE-2012-4561.patch: don't use after free in
      src/keyfiles.c, properly zero structs in src/keys.c.
    - CVE-2012-4561
  * SECURITY UPDATE: denial of service and possible code execution via
    multiple improper overflow checks
    - debian/patches/CVE-2012-4562.patch: do proper overflow checks in
      src/buffer.c, src/dh.c, src/string.c.
    - CVE-2012-4562

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 22 Nov 2012 14:03:19 -0500

libssh (0.5.2-1) unstable; urgency=low

  * New upstream release
    - Fix bug with ssh_channel_write (Closes: #631950)
  * debian/watch: Use new tarball location

 -- Laurent Bigonville <bigon@debian.org>  Mon, 19 Sep 2011 12:01:26 +0200

libssh (0.5.1-1) unstable; urgency=low

  * New upstream release (Closes: #637445)
  * debian/patches/0001-rename-threads-static.patch,
    debian/patches/0002-Check-for-NULL-pointers-in-string-c.patch: Dropped
  * debian/rules:
    - Adjust rule that build documentation
  * debian/patches/0001-disable-latex-documentation.patch: Disable LaTeX
    documentation generation (Closes: #622108)
  * debian/control: Drop texlive-fonts-recommended build-dependency
  * debian/patches/0002-fix-html-doc-generation.patch: Fix HTML doc generation
    (LP: #821437)
  * debian/libssh-doc.doc-base: Refine Title and Files glob

 -- Laurent Bigonville <bigon@debian.org>  Fri, 19 Aug 2011 00:46:48 +0200

libssh (0.5.0-2) unstable; urgency=low

  * debian/patches/0002-Check-for-NULL-pointers-in-string-c.patch:
    Consolidate patch (Should fix previous REJECT)
  * Support multiarch spec

 -- Laurent Bigonville <bigon@debian.org>  Wed, 15 Jun 2011 15:48:07 +0200

libssh (0.5.0-1) unstable; urgency=low

  * New upstream release
  * debian/control:
    - Bump Standards-Version to 3.9.2 (no further changes)
    - Fix short description to please lintian
  * debian/libssh-dev.install:
    - Remove "static" from the static library name
    - Install pkg-config file
  * debian/libssh-4.symbols: Add new symbols to .symbols file
  * debian/patch/0001-rename-threads-static.patch:
    Rename libssh_threads_static.so to libssh_threads.so
  * debian/libssh-4.install, debian/libssh-dev.install, debian/libssh-4.symbols,
    debian/libssh-4.lintian-overrides: Install libssh_threads library
  * debian/patches/0002-Check-for-NULL-pointers-in-string-c.patch:
    Check if string is NULL.

 -- Laurent Bigonville <bigon@debian.org>  Fri, 10 Jun 2011 22:47:54 +0200

libssh (0.4.8-2) unstable; urgency=low

  * Upload to unstable
  * debian/control: Add texlive-fonts-recommended to Build-Depends-Indep
    (Closes: #608319)

 -- Laurent Bigonville <bigon@debian.org>  Sun, 13 Mar 2011 22:06:00 +0100

libssh (0.4.8-1) experimental; urgency=low

  * New upstream release
  * Bump debhelper compatibility to 8

 -- Laurent Bigonville <bigon@debian.org>  Mon, 17 Jan 2011 19:31:47 +0100

libssh (0.4.7-1) experimental; urgency=low

  * New upstream release
    - Drop all patches, applied upstream
  * debian/watch: Fix URL regex

 -- Laurent Bigonville <bigon@debian.org>  Tue, 04 Jan 2011 21:24:34 +0100

libssh (0.4.6-1) experimental; urgency=low

  * New upstream release

 -- Laurent Bigonville <bigon@debian.org>  Mon, 13 Dec 2010 23:30:03 +0100

libssh (0.4.5-3) unstable; urgency=low

  * d/p/0002-socket-Fixed-uninitialized-fd-revents-member.patch:
    Fix uninitialized memory use (Closes: #606347)

 -- Laurent Bigonville <bigon@debian.org>  Sat, 11 Dec 2010 01:33:45 +0100

libssh (0.4.5-2) unstable; urgency=low

  * Add d/p/0001-socket.c-Fixed-setting-max_fd-which-breaks-ssh_selec.patch:
    Fix slow response in Remmina SSH (Closes: #599687, LP: #663777)
  * debian/control: Bump Standards-Version to 3.9.1 (no futher changes)
  * debian/copyright: Update copyright file to please lintian

 -- Laurent Bigonville <bigon@debian.org>  Wed, 20 Oct 2010 20:45:48 +0200

=== debian/watch ===
version=3
https://red.libssh.org/projects/libssh/files \
    /attachments/download/\d+/libssh-(.*)\.tar.gz

## libssh 0.5.3

=== debian/changelog ===
libssh (0.5.3-1~bpo60+1) squeeze-backports; urgency=low

  * Rebuild for squeeze-backports.

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 02 Dec 2012 16:29:09 +0100

libssh (0.5.3-1) unstable; urgency=high

  * New upstream security release
    - Fixes CVE-2012-4559, CVE-2012-4560, CVE-2012-4561, CVE-2012-4562
    - Fix regression in pre-connected socket setting (Closes: #688700)

 -- Laurent Bigonville <bigon@debian.org>  Wed, 21 Nov 2012 13:53:14 +0100

libssh (0.5.2-1~bpo60+1) squeeze-backports; urgency=low

  * Rebuild for squeeze-backports.
  * Revert "Support multiarch spec" to unbreak compilation in stable

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 08 May 2012 20:32:52 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: libs
 Priority: optional
 Maintainer: Laurent Bigonville <bigon@debian.org>
-Build-Depends: cdbs, debhelper (>= 7), cmake (>= 2.6), libssl-dev, libz-dev
+Build-Depends: cdbs, debhelper (>= 8), cmake (>= 2.6), libssl-dev, libz-dev
 Build-Depends-Indep: doxygen
-Standards-Version: 3.9.0
+Standards-Version: 3.9.2
 Vcs-Git: git://git.debian.org/git/collab-maint/libssh.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/libssh.git
 Homepage: http://www.libssh.org/
@@ -12,7 +12,7 @@
 Package: libssh-4
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Description: A tiny C SSH library
+Description: tiny C SSH library
  The ssh library was designed to be used by programmers needing a working SSH
  implementation by the mean of a library. The complete control of the client
  is made by the programmer. With libssh, you can remotely execute programs,
@@ -26,7 +26,7 @@
 Suggests: libssh-doc
 Conflicts: libssh-2-dev
 Replaces: libssh-2-dev
-Description: A tiny C SSH library. Development files
+Description: tiny C SSH library. Development files
  The ssh library was designed to be used by programmers needing a working SSH
  implementation by the mean of a library. The complete control of the client
  is made by the programmer. With libssh, you can remotely execute programs,
@@ -40,7 +40,7 @@
 Section: debug
 Architecture: any
 Depends: libssh-4 (= ${binary:Version}), ${misc:Depends}
-Description: A tiny C SSH library. Debug symbols
+Description: tiny C SSH library. Debug symbols
  The ssh library was designed to be used by programmers needing a working SSH
  implementation by the mean of a library. The complete control of the client
  is made by the programmer. With libssh, you can remotely execute programs,
@@ -56,7 +56,7 @@
 Depends: ${misc:Depends}
 Conflicts: libssh-2-doc
 Replaces: libssh-2-doc
-Description: A tiny C SSH library. Documentation files
+Description: tiny C SSH library. Documentation files
  The ssh library was designed to be used by programmers needing a working SSH
  implementation by the mean of a library. The complete control of the client
  is made by the programmer. With libssh, you can remotely execute programs,

=== debian/rules ===
#!/usr/bin/make -f

DEB_AUTO_CLEANUP_RCS            := yes

DEB_CMAKE_EXTRA_FLAGS := -DWITH_STATIC_LIB=ON

include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/debhelper.mk

DEB_DBG_PACKAGE_libssh-4 = libssh-dbg

# List any files which are not installed
include /usr/share/cdbs/1/rules/utils.mk
common-binary-post-install-arch:: list-missing

build/libssh-doc::
	$(MAKE) -C $(DEB_BUILDDIR) doc

## libssh 0.5.4

=== debian/changelog ===
libssh (0.5.4-3~bpo70+1) wheezy-backports; urgency=low

  * Upload to wheezy-backports.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 14 May 2014 09:51:36 +0200

libssh (0.5.4-3) unstable; urgency=high

  [ Mike Gabriel ]
  * debian/rules:
    + Add get-orig-source rule.
  * debian/watch:
    + Handle tar.gz and tar.xz upstream tarballs alike.
  * debian/copyright.in:
    + Ship auto-generated copyright file in debian/ folder.

  [ Laurent Bigonville ]
  * debian/patches/0007-security-fix-for-vulnerability-CVE-2014-0017.patch:
    Reset the PRNG state after acception a new connection (CVE-2014-0017)

 -- Laurent Bigonville <bigon@debian.org>  Wed, 05 Mar 2014 22:42:19 +0100

libssh (0.5.4-2) unstable; urgency=low

  * debian/control:
    + Add myself to Uploaders: field as discussed with current
      maintainer on IRC (#debian-devel) on 2014-02-17.
    + Alioth-canonicalize Vcs-* fields.
  * debian/copyright:
    + Make copyright file DEP-5 compliant.
    + Relicense debian/* files under all licenses used by upstream.
      Copyright holders' agreements can be found in the related
      bug report in Debian BTS. (Closes: #739372).
  * debian/patches:
    + Add patch 0004-reset-global-request-status.patch: Allow requesting
      more than one channel per session.
    + Add patch 0005-multi-reverse-fwd.patch: Ease handling of multiple
      reverse port forwarding requests per session. (Closes: #736231).
    + Add patch 0006-ssh-handle-package-zero-timeouts.patch: Handle
      zero timeouts as such. Improves speed on libssh issued
      connections. (Closes: #738667).
  * Update libssh-4.symbols file with new symbol introduced by patch
    0005-multi-reverse-fwd.patch.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 18 Feb 2014 13:34:13 +0100

libssh (0.5.4-1) unstable; urgency=low

  * New upstream security release
    - Fix NULL dereference leads to denial of service
      (Closes: #698963, CVE-2013-0176)
  * debian/patches/0003-fix-typo.patch: Fix typo in error message

 -- Laurent Bigonville <bigon@debian.org>  Tue, 05 Feb 2013 01:06:40 +0100

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,20 @@
 Section: libs
 Priority: optional
 Maintainer: Laurent Bigonville <bigon@debian.org>
-Build-Depends: cdbs, debhelper (>= 8), cmake (>= 2.6), libssl-dev, libz-dev
+Uploaders:
+ Mike Gabriel <sunweaver@debian.org>,
+Build-Depends: cdbs (>= 0.4.93~), debhelper (>= 8.1.3~), cmake (>= 2.6), libssl-dev, libz-dev
 Build-Depends-Indep: doxygen
 Standards-Version: 3.9.2
-Vcs-Git: git://git.debian.org/git/collab-maint/libssh.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/libssh.git
+Vcs-Git: git://anonscm.debian.org/collab-maint/libssh.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/libssh.git
 Homepage: http://www.libssh.org/
 
 Package: libssh-4
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Pre-Depends: ${misc:Pre-Depends}
+Multi-Arch: same
 Description: tiny C SSH library
  The ssh library was designed to be used by programmers needing a working SSH
  implementation by the mean of a library. The complete control of the client
@@ -40,6 +44,7 @@
 Section: debug
 Architecture: any
 Depends: libssh-4 (= ${binary:Version}), ${misc:Depends}
+Multi-Arch: same
 Description: tiny C SSH library. Debug symbols
  The ssh library was designed to be used by programmers needing a working SSH
  implementation by the mean of a library. The complete control of the client

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 DEB_AUTO_CLEANUP_RCS            := yes
 
-DEB_CMAKE_EXTRA_FLAGS := -DWITH_STATIC_LIB=ON
+DEB_CMAKE_EXTRA_FLAGS := -DWITH_STATIC_LIB=ON -DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)
 
 include /usr/share/cdbs/1/class/cmake.mk
 include /usr/share/cdbs/1/rules/debhelper.mk
@@ -15,3 +15,6 @@
 
 build/libssh-doc::
 	$(MAKE) -C $(DEB_BUILDDIR) doc
+
+get-orig-source:
+	uscan --noconf --force-download --rename --download-current-version --destdir=..
